import requests
import math
from numpy import log as ln

def get_lat_lon(callsign='N502SX'):
    # uses the api to get the latitude and longitude and returns a list of 2 ints
    url = 'https://adsbexchange-com1.p.rapidapi.com/v2/callsign/' + callsign + '/'
    headers = {
        "X-RapidAPI-Host": "adsbexchange-com1.p.rapidapi.com",
        "X-RapidAPI-Key": "27d6e0192emsh0b0d9c0364793c1p175136jsn803c2abbbc60"
    }
    response = requests.get(url, headers=headers)
    data = response.text

    lat, lon = 0.0, 0.0
    flying = False

    for i in range(len(data)):
        if data[i: i + 6] == '"lat":':
            lenNum = 1
            while data[i + lenNum] != ',':
                lenNum += 1
            lat = float(data[i + 6: i + lenNum])
            flying = True
        elif data[i: i + 6] == '"lon":':
            lenNum = 1
            while data[i + lenNum] != ',':
                lenNum += 1
            lon = float(data[i + 6: i + lenNum])
            flying = True

    return [lon, lat], flying

def lat_lon_to_xy(pos): 
# Define the size of map
    mapWidth    = 584.2
    mapHeight   = 431.8


    # get x value
    x = (pos[0] + 180) * (mapWidth / 360)

    # convert from degrees to radians
    latRad = (pos[1] * math.pi) / 180

    # get y value
    mercN = ln(math.tan((math.pi / 4) + (latRad / 2)))
    y     = (mapHeight / 2) - (mapWidth * mercN / (2 * math.pi))
    
    return [x, mapHeight-y] # mapHeight - y makes the origin point from the bottom left corner for the latitude 

