import apiData #hello
from stepper import Stepper
import math
from time import sleep
import RPi.GPIO as GPIO

__name__ = 'main'

if __name__ == 'main':
    gear_diameter = 12
    gear_cirumference = 12 * math.pi
    step_dist = gear_cirumference / 200

    GPIO.setmode(GPIO.BOARD)
    motorx_chan = (29, 31, 33, 35)
    motory_chan = (32, 36, 38, 40)
    GPIO.setup(motorx_chan, GPIO.OUT)
    GPIO.setup(motory_chan, GPIO.OUT)
    stepperx = Stepper(motorx_chan, 0.005)  # add pins and stuff later
    steppery = Stepper(motory_chan, 0.005) # add pins and stuff later
    callsign = input('Enter a callsign of a plane to track: ')

    # steps from corner 9.42477796076938mm each direction to get to map 0
    #stepperx.step_cw(50)
    #steppery.step_cw(50)
    pos = [0, 0]

    while True:
        latLon, flying = apiData.get_lat_lon(callsign)
        print(latLon)
        if not flying:
            stepperx.clear()
            steppery.clear()
            sleep(60)
        else:
            new_pos = apiData.lat_lon_to_xy(latLon)
            new_pos[1] -= 31.75
            new_pos[1] %= 431.8
            print(new_pos)
            while new_pos[0] > pos[0]:
                stepperx.step_cw(1)
                pos[0] += step_dist
            while new_pos[0] < pos[0]:
                stepperx.step_ccw(1)
                pos[0] -= step_dist
            while new_pos[1] > pos[1]:
                steppery.step_ccw(1)
                pos[1] += step_dist
            while new_pos[1] < pos[1]:
                steppery.step_cw(1)
                pos[1] -= step_dist
            stepperx.clear()
            steppery.clear()
            sleep(60)
