import RPi.GPIO as GPIO
from time import sleep

class Stepper():
    def __init__(self, chan, delayTime):
        self.chan = chan
        self.delayTime = delayTime
        self.phase = 0

    def run_step(self):
        if self.phase == 0:
            GPIO.output(self.chan, (GPIO.HIGH, GPIO.LOW, GPIO.HIGH, GPIO.LOW))
        elif self.phase == 1:
            GPIO.output(self.chan, (GPIO.LOW, GPIO.HIGH, GPIO.HIGH, GPIO.LOW))
        elif self.phase == 2:
            GPIO.output(self.chan, (GPIO.LOW, GPIO.HIGH, GPIO.LOW, GPIO.HIGH))
        elif self.phase == 3:
            GPIO.output(self.chan, (GPIO.HIGH, GPIO.LOW, GPIO.LOW, GPIO.HIGH))
        sleep(self.delayTime)

    def step_cw(self, num_steps):
        for i in range(num_steps):
            self.phase = (self.phase + 1) % 4
            self.run_step()
    
    def step_ccw(self, num_steps):
        for i in range(num_steps):
            self.phase = (self.phase - 1) % 4
            self.run_step()
    
    def clear(self):
        GPIO.output(self.chan, (GPIO.LOW, GPIO.LOW, GPIO.LOW, GPIO.LOW))
